//#include "jobs.h"
#include "KVStore.c"

#include<stdlib.h>
#include<stdio.h>
#include<string.h>

long int getSetId(char * key){
	return strlen(key);
}

kvcache_data** init_cache(){
	kvcache_data **t = (kvcache_data **)malloc(256 * sizeof(kvcache_data *));
	for (int i = 0; i < 256; ++i){
		t[i] = (kvcache_data *)malloc( sizeof(kvcache_data)*10);
		for(int j=0;j<10;j++){
			t[i][j].chance=-1;
		}
		}
	
	return t;
}
int* rep_line_per_set(){
	int* x=(int *)calloc(sizeof(int),256);
	for(int i=0;i<256;i++){
		x[i]=0;
	}
	return x;
}
int getInCache(kvcache_data** t,int* repl,char *key,char *value){
	int ln=getSetId(key)-1;
	for(int i=0;i<10;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=1;
				strcpy(value,t[ln][i].value);
				return 1;
			}	
		}
		else{
			break;
		}
	}

	int temp=repl[ln];
	while(t[ln][temp].chance==1){
		t[ln][temp].chance=0;
		repl[ln]=(repl[ln]+1)%10;
		temp=repl[ln];
	}
	if(!restoreFromFile(key,value)){
		return 0;
	}
	else{
		strcpy(t[ln][temp].key,key);
		strcpy(t[ln][temp].value,value);
		repl[ln]=(repl[ln]+1)%10;
		t[ln][temp].chance=0;
		return 1;
		
	}
	
	


}
int postInCache(kvcache_data** t,int* repl,char *key,char *value){
	int ln=getSetId(key)-1;
	for(int i=0;i<10;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=1;
				strcpy(t[ln][i].value,value);
				return 1;
			}	
		}
		else{
			break;
		}
	}
	int temp=repl[ln];
	while(t[ln][temp].chance==1){
		t[ln][temp].chance=0;
		repl[ln]=(repl[ln]+1)%10;
		temp=repl[ln];
	}
	//printf("%d\n",temp);
	strcpy(t[ln][temp].key,key);
	strcpy(t[ln][temp].value,value);
	repl[ln]=(repl[ln]+1)%10;
	t[ln][temp].chance=0;
		
	if(dumpToFile(&t[ln][temp])){
		return 1;
	}
	else{
		return 0;
	}
	return 1;
}
int delInCache(kvcache_data** t,int* repl,char *key){
	int flag=0;
	int ln=getSetId(key)-1;
	for(int i=0;i<10;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=0;
				strcpy(t[ln][i].key,"");
				strcpy(t[ln][i].value,"");
				
			}	
		}
		else{
			break;
		}
	}

	if(deleteFromFile(key)){
		return 1;
	}
	else{
		return 0;
	}
}
/*
int main(){
kvcache_data **t= init_cache();
int *repl=rep_line_per_set();

char value[1232];
printf("%d\n",postInCache(t,repl,"x","xenon"));
printf("%d\n",postInCache(t,repl,"y","yak"));
printf("%d\n",getInCache(t,repl,"y",value));
printf("%d\n",delInCache(t,repl,"y"));
printf("%d\n",getInCache(t,repl,"z",value));	


for(int i =0;i<10;i++){
	printf("%d %d %s %s\n",i,t[1-1][i].chance,t[1-1][i].key,t[1-1	][i].value);
}
}
*/
